//+------------------------------------------------------------------+
//|                                            ChinkouSpan Trend.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Black
#property indicator_color3 Yellow
//--- input parameters
extern int       A=9;
extern int       B=18;
extern int       C=36;
extern bool      Continuation = True;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY, 4, Lime);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY, 4, Black);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY, 4, Yellow);
   SetIndexBuffer(2,ExtMapBuffer3);   
   IndicatorShortName("ChinKou Span TREND ("+A+","+B+","+C+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,OldValue=0,Bx;
   double   spanvalue;
   int    counted_bars=IndicatorCounted();
//----
   i=Bars-counted_bars-1;           // Index of the first uncounted
   while(i>=0)                      // Loop for uncounted bars
     {
     spanvalue = iIchimoku(NULL, 0, A, B, C, MODE_CHINKOUSPAN, i+B);
     if (Continuation)
         {
         if ((spanvalue > iHigh(NULL,0,i+B)) || ( OldValue==1 && spanvalue >= iLow(NULL,0,i+B) && spanvalue <= iHigh(NULL,0,i+B))) {OldValue=1;ExtMapBuffer1[i]=1; ExtMapBuffer2[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}
         if ((spanvalue < iLow(NULL,0,i+B)) || ( OldValue==0 && spanvalue >= iLow(NULL,0,i+B) && spanvalue <= iHigh(NULL,0,i+B))) {OldValue=0;ExtMapBuffer2[i]=1;ExtMapBuffer1[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}    
         }
     if (!Continuation)
         {        
         if (spanvalue > iHigh(NULL,0,i+B)) {ExtMapBuffer1[i]=1; ExtMapBuffer2[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}
         if (spanvalue < iLow(NULL,0,i+B)) {ExtMapBuffer2[i]=1; ExtMapBuffer1[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}
         if (spanvalue >= iLow(NULL,0,i+B) && spanvalue <= iHigh(NULL,0,i+B)) {ExtMapBuffer3[i]=1;ExtMapBuffer2[i]=EMPTY_VALUE;ExtMapBuffer1[i]=EMPTY_VALUE;} 
         }  
     i--;     
     }       
//----
   return(0);
  }
//+------------------------------------------------------------------+